-- Quick Menu ******************************************************************
sc_btnASM_CustomizeQuickMenu_OnRelease_orig = sc_btnASM_CustomizeQuickMenu_OnRelease
sc_btnASM_CustomizeQuickMenu_OnRelease = function()
   MODEL.ui.lst_MenuList.current_page = 0
  sc_NextStateAnim(st_CustomizeQuickMenu, "horz_scroll", 1, "")
end

sc_FindFirstNotUsedItemInFullList_orig = sc_FindFirstNotUsedItemInFullList
sc_FindFirstNotUsedItemInFullList = function()
  for item,index in ModelList_iter(MODEL.ui.fullMapLocalMenuList) do
    local used = false
    for i = 0, 44 do
      local itemIdx = PERSISTENT.QMsavedMapLocalMenu[i]()
      if itemIdx == item.id() then
        used = true
      end
    end
    if not used then
      return index
    end
  end
end

sc_BuildMapLocalMenu_orig = sc_BuildMapLocalMenu
sc_BuildMapLocalMenu = function()
  local menuItems = {}
  for i = 0, 14 do
    local itemIdx = sc_FindItemInFullList(PERSISTENT.QMsavedMapLocalMenu[i]())
    MODEL.ui.fullMapLocalMenuList[itemIdx].is_in_menu = true
    MODEL.ui.fullMapLocalMenuList[itemIdx].menu_index = i
    PERSISTENT.QMsavedMapLocalMenu[i] = MODEL.ui.fullMapLocalMenuList[itemIdx].id()
  end
end

sc_ReplaceSelectedMapLocalMenuItem_orig = sc_ReplaceSelectedMapLocalMenuItem
sc_ReplaceSelectedMapLocalMenuItem = function(itemId)
  local oldId = PERSISTENT.QMsavedMapLocalMenu[vMapMenuButtonAct]()
  local oldItemIdx = sc_FindItemInFullList(oldId)
  local newItemIdx = sc_FindItemInFullList(itemId)
  if MODEL.ui.fullMapLocalMenuList[newItemIdx].is_in_menu() then
    if itemId == oldId then
      return
    end
    local newItemIdxForSwap = MODEL.ui.fullMapLocalMenuList[newItemIdx].menu_index()
    MODEL.ui.fullMapLocalMenuList[oldItemIdx].menu_index = MODEL.ui.fullMapLocalMenuList[newItemIdx].menu_index()
    MODEL.ui.fullMapLocalMenuList[newItemIdx].menu_index = vMapMenuButtonAct
    PERSISTENT.QMsavedMapLocalMenu[vMapMenuButtonAct] = itemId
    PERSISTENT.QMsavedMapLocalMenu[newItemIdxForSwap] = oldId
  else
    MODEL.ui.fullMapLocalMenuList[oldItemIdx].is_in_menu = false
    MODEL.ui.fullMapLocalMenuList[oldItemIdx].menu_index = 100
    MODEL.ui.fullMapLocalMenuList[newItemIdx].is_in_menu = true
    MODEL.ui.fullMapLocalMenuList[newItemIdx].menu_index = vMapMenuButtonAct
    PERSISTENT.QMsavedMapLocalMenu[vMapMenuButtonAct] = itemId
  end
end


rikRICalckEvent = 0
rikTiHorCorrect = false

sc_start_customize = function()
  sc_rik_ColorBarChange()
  sc_rik_FontSizeChange()
  obs_timer:START()
  sc_SetCarPosY()
  MODEL.lua.MaxTK_Zone_Approche = sc_GetSysEntry("navigation", "maxtkzoneapproche", 2000)
  if MODEL.lua.MaxTK_Zone_Approche() > 5000 then
    MODEL.lua.MaxTK_Zone_Approche = 5000
  elseif MODEL.lua.MaxTK_Zone_Approche() < 2000 then
    MODEL.lua.MaxTK_Zone_Approche = 2000
  end
  if MODEL.lua.TK_Zone_Approche() > MODEL.lua.MaxTK_Zone_Approche() then
    MODEL.lua.TK_Zone_Approche = 2000
  end
end
 
sc_set_MAPresolution()

--day & night & NextStreet
sc_vDayNightTrigger = function()
  MODEL.lua.vDayNightTrigger = false
  MODEL.lua.vDayNightTrigger = true
end

sc_vTrigger = function()
  MODEL.lua.vrikTrigger = false
  MODEL.lua.vrikTrigger = true
end

sc_change_day_night = function()
  sc_vDayNightTrigger()
  sc_rik_Opaque_OnOff()
end

sc_SetTheme_orig = sc_SetTheme
sc_SetTheme = function()
  LOGPRINT("Change Colour")
  local themeList = MODEL.screen.theme.list
  MODEL.screen.theme.change_theme(themeList[themeList.index()].filename(), isItNightTheme)
  sc_vDayNightTrigger()
end

--Country Info
gCountryChangedMsgID = -1
gCountryChangedMsgCountryIndex = nil
sc_OnCountryChanged = function()
  if MODEL.navigation.is_in_simulation() then
    return 
  end
  if not MODEL.lua.countrycrossing() then
	return
  end
  local currentCountry = MODEL.navigation.car.current_country
  local countryInfo = MODEL.other.country_info
  if not currentCountry.valid() or currentCountry() == "" then
    return 
  end
  if MODEL.lua.last_country() == "" then
    MODEL.lua.last_country = currentCountry()
    return 
  end
  if MODEL.lua.last_country() ~= currentCountry() then
    MODEL.lua.last_country = currentCountry()
  else
    return 
  end
  countryInfo.select_country(currentCountry())
  if countryInfo.list.index() == -1 then
    return 
  end
  sc_RemoveMapPopupById(gCountryChangedMsgID)
  gCountryChangedMsgCountryIndex = countryInfo.list.index()
  if MODEL.lua.ReadOutCountryInfo() then
    sc_ReadOutCountryInfo()
  end
  local country = countryInfo.list[gCountryChangedMsgCountryIndex]
  local onrelease = ""
  local bmp, phase = nil, nil
  bmp, phase = MODEL.screen.get_icon_file_and_phase(country.flag_icon(), msgboxFlagIconIndex)
  gCountryChangedMsgID = sc_AddMapPopup(2, translated_format(m_i18n("You have entered %s.\nWould you like to see country information?"), country.name()), bmp, country.flag_phase(), "sc_BorderCross_CountryInfo_OnRelease", "", false, 25, 1, nil, nil, "mute_countryinfo_msg")
end

--restart
sc_rik_OK_onRelease = function()
  SAVESETTINGS()
  local newMsgBox = MODEL.screen.msgbox.new
  newMsgBox.setup(2)
  newMsgBox.set_line(1, m_i18n("The program will restart."))
  newMsgBox.setup_button(1, "sc_Restart", m_i18n("Restart"), "", "ico_done_mid.bmp#3")
  newMsgBox.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

 
--current position to favorite
sc_current_add_to_favourite = function()
  MODEL.my.map.select_address(MODEL.navigation.car.position())
  sc_FavouriteCommon()
  sc_NextStateAnim(st_SimpleInputText, "horz_scroll", 1, "")
end


--turn restriction sound
sc_rik_TR_Sound = function()  
  if MODEL.lua.vrikTurnRestSound() and MODEL.lua.vrikTurnRestShow() then
    PLAYSOUND("alarmeffect", "!ding")
  end
end


--trip info fix
sc_AutoCloseCockpit_orig = sc_AutoCloseCockpit
sc_AutoCloseCockpit = function()
  gCockpitAutoClosed = true
  nTiopen = MODEL.lua.vEasyNavTripInfoOpen()
  if (MODEL.lua.CockpitType() == 0 or MODEL.lua.CockpitType() == 1) and MODEL.lua.vEasyNavTripInfoOpen() and not gCockpitJustOpened and not MODEL.lua.vrikTiHorizontal() then
    MODEL.lua.vEasyNavTripInfoOpen = false
  end
end
 
sc_ReopenCockpit_orig = sc_ReopenCockpit
sc_ReopenCockpit = function()
  if nTiopen and gCockpitAutoClosed and not MODEL.lua.vrikTiHorizontal() then
    MODEL.lua.vEasyNavTripInfoOpen = true
  end
  gCockpitAutoClosed = false
end


--trip info horizontal
sc_AutoCloseCockpit_horizontal = function()
  gCockpitAutoClosed = true
  nTiopenH = MODEL.lua.vEasyNavTripInfoOpen()
  if (MODEL.lua.CockpitType() == 0 or MODEL.lua.CockpitType() == 1) and MODEL.lua.vEasyNavTripInfoOpen() and MODEL.lua.vrikTiHorizontal() then
	MODEL.lua.vEasyNavTripInfoOpen = false
  end
end
 
sc_ReopenCockpit_horizontal = function()
  if nTiopenH and gCockpitAutoClosed and MODEL.lua.vrikTiHorizontal() then
    if rikTiHorCorrect then
      doDelayed(1, function()
      	MODEL.lua.vEasyNavTripInfoOpen = true
      end
      )
    else
      MODEL.lua.vEasyNavTripInfoOpen = true
    end
  end
  rikTiHorCorrect = false
  gCockpitAutoClosed = false
  gCockpitJustOpened = false
end

sc_map_local_menu_deleteroute_orig = sc_map_local_menu_deleteroute
sc_map_local_menu_deleteroute = function()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to delete the route?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_DeleteRoute", m_i18n("Cancel Route"), "", "ico_DeleteRoute_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Keep Route"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.new.set_priority(MessageBoxPriority.DeleteRoute)
  MODEL.screen.msgbox.create_new()
  rikTiHorCorrect = true
end

sc_CheckIfCockpitNeedClose_orig = sc_CheckIfCockpitNeedClose
sc_CheckIfCockpitNeedClose = function()
  gCockpitJustOpened = false
  if (MODEL.lua.JunctionViewVisible() and MODEL.navigation.tunnel_view.overview.available() or MODEL.lua.TunnelOverviewVisible()) and not MODEL.lua.vrikTiHorizontal() then
    sc_AutoCloseCockpit()
  end
end

sc_CloseTiHorizontal = function()
  MODEL.lua.vEasyNavTripInfoOpen = false
  rikTiHorCorrect = false
  gCockpitJustOpened = false
end

sc_SelectTiCorrect = function()
  if MODEL.lua.vrikTiHorizontal() and not MODEL.lua.vEasyNavTripInfoOpen() and (MODEL.screen.msgbox.is_onscreen() or MODEL.lua.HwyPoiListIsVisible() or (MODEL.lua.laneInfoVisible() and MODEL.lua.vrikShowLaneInfo() == 1)) then
    rikTiHorCorrect = false
    gCockpitJustOpened = false
  else
    sc_SelectCockpit_Map()
  end
end

sc_SetCarPosY = function()
  if MODEL.lua.vrikTiHorizontal() and not MODEL.lua.vrikShowStaticCurrStreet() then
    MODEL.map.primary.car_posy = 66
  else
    MODEL.map.primary.car_posy = 68
  end
  if MODEL.lua.tripInfoVisible() then
    MODEL.map.primary.car_posx = 52
  else
    MODEL.map.primary.car_posx = 50
  end
end

createState("st_batt_compass")
st_EasyNav:useLayers(primary, "ui_batt_compass")

--visual settings
createState("st_rik_VisualSettings")
st_rik_VisualSettings:useLayers(backgroundLayers, "ui_rik_VisualSettings")
st_rik_VisualSettings.init = function()
  txtTitle.TEXT = m_i18n("Display")
end

sc_rik_Visual_OnRelease = function()
  sc_NextStateAnim(st_rik_VisualSettings, "horz_scroll", 1, "")
end


--font style settings
createState("st_rik_FontStyleSettings")
st_rik_FontStyleSettings:useLayers(backgroundLayers, "ui_rik_FontStyleSettings", localMenuLayers)
st_rik_FontStyleSettings.init = function()
  txtTitle.TEXT = m_i18n("Font Options")
  sc_init_local_menu("ui.fontStyleLocalMenu")
end

sc_rik_FontStyle_OnRelease = function()
  sc_NextStateAnim(st_rik_FontStyleSettings, "horz_scroll", 1, "")
end

sc_rik_ResetFontStyle_OnRelease = function()
  sc_close_local_menu()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Would you like to reset all?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_rik_ResetFontStyle", m_i18n("Reset to Defaults"), "", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

sc_rik_ResetFontStyle = function()
  MODEL.lua.vrikSetFS_single = false
  MODEL.lua.vrikChangeGlow = 2
  MODEL.lua.vrikGlowType = 2
  if uiResW > 530 then
    MODEL.lua.vrikGlowSize = 3
  else
    MODEL.lua.vrikGlowSize = 2
  end
  MODEL.lua.vrikGlowAlpha = 16
end

--reset motor editie
sc_hozz_ResetMotoEdit_OnRelease = function()
  sc_close_local_menu()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Would you like to reset all?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_hozz_ResetMotoEdit", m_i18n("Reset to Defaults"), "", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

sc_hozz_ResetMotoEdit = function()
  MODEL.lua.askforwaitingtime = 0
  MODEL.lua.backlightdetails = 0
  MODEL.lua.calcGreenRoute = 0
  MODEL.lua.CaptureScreen = 0
  MODEL.lua.countrycrossing = true
  MODEL.lua.currentvoiceissupkmm = 1
  MODEL.lua.currentvoiceissupmlf = 1
  MODEL.lua.currentvoiceissupmly = 1
  MODEL.lua.DAEnabled = 1
  MODEL.lua.DesaturatedMap = 1
  MODEL.lua.graphic_eq = 0
  MODEL.lua.hozz_battstatus = true
  MODEL.lua.hozz_compass = false
  MODEL.lua.hozzUseNightmodeInTunnel = true
  MODEL.lua.iconhue = 0
  MODEL.lua.iconhue_backup = 0
  MODEL.lua.linear_compass = 1
  MODEL.lua.mainmenustate = st_MainMenu
  MODEL.lua.mute_hozz = 2
  MODEL.lua.newcompass = 0
  MODEL.lua.newdestarrow = false
  MODEL.lua.OffRoadNav = false
  MODEL.lua.OverViewModeOn = false
  MODEL.lua.ptp_navigation = false
  MODEL.lua.ReadOutRouteSummary = false
  MODEL.lua.RoadBlocking = false
  MODEL.lua.routeComparingEnabled = true
  MODEL.lua.routemethodlistindex = 0
  MODEL.lua.saved_detailmode = normal
  MODEL.lua.set_route_start_time_enabled = false
  MODEL.lua.SignpostOn = true
  MODEL.lua.SkipPreviewMap = true
  MODEL.lua.speedlimitpercent = false
  MODEL.lua.speedwarningalwaysvisiblechk = false
  MODEL.lua.thl_lc_mode = 0
  MODEL.lua.TK_WayPoint = true
  MODEL.lua.TK_WayPointPop = true
  MODEL.lua.TK_WayPointPop_always = false
  MODEL.lua.TK_Zone_Approche = 300
  MODEL.lua.TrackShowOnMap = true
  MODEL.lua.tripInfoVisible = false
  MODEL.lua.vAvoidUTurn = true
  MODEL.lua.vdeviceactivationfromgetextras = true
  MODEL.lua.vEasyColorMode = 2
  MODEL.lua.vEasyMapMode = 1
  MODEL.lua.vEasyNavMapMenuActive = false
  MODEL.lua.vEasyNavTripInfoOpen = true
  MODEL.lua.vEasyViewMode = true
  MODEL.lua.vEasyWizModeOnFirstStart = false
  MODEL.lua.volume_unit = 3
  MODEL.lua.vrik2D3DBtn = 0
  MODEL.lua.vrik_ALPHA_all = true
  MODEL.lua.vrik_ALPHA_currstreet = 32
  MODEL.lua.vrik_ALPHA_laneinfo = 32
  MODEL.lua.vrik_ALPHA_maneuver = 20
  MODEL.lua.vrik_ALPHA_nextstreet = 30
  MODEL.lua.vrik_ALPHA_quickmenu = 20
  MODEL.lua.vrik_ALPHA_secondmaneuver = 20
  MODEL.lua.vrik_ALPHA_tripiconhor = 16
  MODEL.lua.vrik_ALPHA_tripinfo = 32
  MODEL.lua.vrik_ALPHA_tripinfohor = 32
  MODEL.lua.vrikATPEnable = false
  MODEL.lua.vrikChangeFS_advspeed = 120
  MODEL.lua.vrikChangeFS_distman = 138
  MODEL.lua.vrikChangeFS_highw = 120
  MODEL.lua.vrikChangeFS_housenum = 120
  MODEL.lua.vrikChangeFS_infobar = 124
  MODEL.lua.vrikChangeFS_speedlimit = 134
  MODEL.lua.vrikChangeFS_tripcomp = 116
  MODEL.lua.vrikChangeFS_tripinfo = 120
  MODEL.lua.vrikChangeGlow = 1
  MODEL.lua.vrikCityName = true
  MODEL.lua.vrikColorChangeInfobar = 1
  MODEL.lua.vrikColorFontstreet = 0
  MODEL.lua.vrikColorSet = 0
  MODEL.lua.vrikColorSetCs = 1
  MODEL.lua.vrikColorSetDark = 1
  MODEL.lua.vrikColorSetDarkHor = 1
  MODEL.lua.vrikColorSetHw = 1
  MODEL.lua.vrikColorSetMan = 0
  MODEL.lua.vrikColorSetMid = 1
  MODEL.lua.vrikfontCsBd = 1
  MODEL.lua.vrikfontOther = 1
  MODEL.lua.vrikFontSizeAdvspeed = 100
  MODEL.lua.vrikFontSizeAll = 120
  MODEL.lua.vrikFontSizeDistman = 100
  MODEL.lua.vrikFontSizeHighw = 100
  MODEL.lua.vrikFontSizeInfobar = 124
  MODEL.lua.vrikFontSizeSpeedlimit = 100
  MODEL.lua.vrikFontSizeTripcomp = 100
  MODEL.lua.vrikFontSizeTripinfo = 100
  MODEL.lua.vrikFontSpeedlimit = 1
  MODEL.lua.vrikGlowAlpha = 32
  MODEL.lua.vrikGlowSize = 2
  MODEL.lua.vrikGlowType = 2
  MODEL.lua.vrikGPSManStatus = true
  MODEL.lua.vrikHouseNum = 2
  MODEL.lua.vrikIconOnQMBtn = 0
  MODEL.lua.vrikinfobar = false
  MODEL.lua.vrikinfobarAdd = false
  MODEL.lua.vrikinfobarAll = false
  MODEL.lua.vrikinfoFont = 2
  MODEL.lua.vrikinfoFontColor = 3
  MODEL.lua.vrikinfoIconLeft = 0
  MODEL.lua.vrikinfoIconRight = 0
  MODEL.lua.vrikinfoTripLeft_open = 7
  MODEL.lua.vrikinfoTripRight_open = 0
  MODEL.lua.vrikinfoWayPointsRight = 1
  MODEL.lua.vrikinfoWidth = 1
  MODEL.lua.vrikMiniJunction = 0
  MODEL.lua.vrikOvsButtonTxt = 1
  MODEL.lua.vrikRecalcInfoColor = 1
  MODEL.lua.vrikRecalcInfoEnable = false
  MODEL.lua.vrikRITmpDist = 0
  MODEL.lua.vrikRITmpTime = 0
  MODEL.lua.vrikSetFS_single = 0
  MODEL.lua.vrikShowAvgSpeed = false
  MODEL.lua.vrikShowDynamicNextStreet = true
  MODEL.lua.vrikShowLaneInfo = 1
  MODEL.lua.vrikShowRecIcon = true
  MODEL.lua.vrikShowSecMan = 4
  MODEL.lua.vrikShowStaticCurrStreet = false
  MODEL.lua.vrikShowTimeToMan = 0
  MODEL.lua.vrikTiHorizontal = true
  MODEL.lua.vrikTimeFontColor = 0
  MODEL.lua.vrikTMCasQuick = false
  MODEL.lua.vrikTMCborder = false
  MODEL.lua.vrikTrackBgColor = 1
  MODEL.lua.vrikTripComp = true
  MODEL.lua.vrikTripDataRecStop = false
  MODEL.lua.vrikTripFontColor = 3
  MODEL.lua.vrikTruckRestric = false
  MODEL.lua.vrikTruckTime = 0
  MODEL.lua.vrikTurnRestRight = 0
  MODEL.lua.vrikTurnRestShow = false
  MODEL.lua.vrikTurnRestSound = false
  MODEL.lua.vrikVRFontColor = 0
  MODEL.lua.wautorecalc = true
  MODEL.lua.woverview_northup = 1
  MODEL.lua.wskipradius = 1500
  MODEL.interface.collect_statistics = 0
  MODEL.interface.current_day_color_original_name = "Test Mark 2"
  MODEL.interface.current_night_color_original_name = "COLORSCHEME~Default Night Colours"
  MODEL.interface.default_anim_off = 0
  MODEL.interface.show_bugreport = 0
  MODEL.interface.theme = "skin\Decent_skin_Motor_Editie.zip"
  MODEL.interface.theme_day = "skin\Decent_skin_Motor_Editie.zip"
  MODEL.interface.theme_night = "skin\Decent_skin_Motor_Editie.zip"
  MODEL.sound.os_muted = 0
  MODEL.sound.os_volume = 128
  MODEL.sound.voice_muted = 0
  MODEL.sound.voice_volume = 108
  sc_rik_Opaque_OnOff()
  sc_Restart()
end


--transparency settings
createState("st_rik_transparency_Settings")
st_rik_transparency_Settings:useLayers(backgroundLayers, "ui_rik_transparency_Settings", localMenuLayers)
st_rik_transparency_Settings.init = function()
  txtTitle:SET(m_i18n("Transparency"))
  sc_init_local_menu("ui.transparencyLocalMenu")
end

sc_rik_transparency_OnRelease = function()
  sc_NextStateAnim(st_rik_transparency_Settings, "horz_scroll", 1, "")
end

sc_rik_ResetTransparency_OnRelease = function()
  sc_close_local_menu()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Would you like to reset all?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_rik_ResetTransparency", m_i18n("Reset to Defaults"), "", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

sc_rik_ResetTransparency = function()
  MODEL.lua.vrik_ALPHA_all = true
  MODEL.lua.vrik_ALPHA_maneuver = 27
  MODEL.lua.vrik_ALPHA_secondmaneuver = 16
  MODEL.lua.vrik_ALPHA_nextstreet= 20
  MODEL.lua.vrik_ALPHA_quickmenu = 27	
  MODEL.lua.vrik_ALPHA_currstreet= 16
  MODEL.lua.vrik_ALPHA_signs = 32
  MODEL.lua.vrik_ALPHA_restsigns = 32
  MODEL.lua.vrik_ALPHA_infoicon = 27
  MODEL.lua.vrik_ALPHA_tripinfo = 27
  MODEL.lua.vrik_ALPHA_tripinfohor = 27
  MODEL.lua.vrik_ALPHA_tripcompbg = 13
  MODEL.lua.vrik_ALPHA_tripcomptxt = 32
  MODEL.lua.vrik_ALPHA_cityhouse = 32
  MODEL.lua.vrik_ALPHA_border = 32
  MODEL.lua.vrik_ALPHA_border = 32
  MODEL.lua.vrik_ALPHA_signpost = 32
  MODEL.lua.vrik_ALPHA_JTV = 32
  MODEL.lua.vrik_ALPHA_mini = 13
  MODEL.lua.vrik_ALPHA_laneinfo = 23
  MODEL.lua.vrik_ALPHA_speedlimit = 20
  MODEL.lua.vrik_ALPHA_speedalert = 16
  MODEL.lua.vrik_ALPHA_table = 16
  if MODEL.lua.vrikColorInfobar() then
    MODEL.lua.vrik_OPAQUE_infobar(MODEL.lua.vrik_ALPHA_infobar())
  else
    MODEL.lua.vrik_ALPHA_infobar = 0
  end
  sc_rik_Opaque_OnOff()
end

sc_rik_Opaque_OnOff = function()
  if MODEL.lua.vrik_ALPHA_all() then
    MODEL.lua.vrik_OPAQUE_maneuver(MODEL.lua.vrik_ALPHA_maneuver())
    MODEL.lua.vrik_OPAQUE_secondmaneuver(MODEL.lua.vrik_ALPHA_secondmaneuver())
    MODEL.lua.vrik_OPAQUE_nextstreet(MODEL.lua.vrik_ALPHA_nextstreet())
    MODEL.lua.vrik_OPAQUE_quickmenu(MODEL.lua.vrik_ALPHA_quickmenu())
    MODEL.lua.vrik_OPAQUE_currstreet(MODEL.lua.vrik_ALPHA_currstreet())
    MODEL.lua.vrik_OPAQUE_signs(MODEL.lua.vrik_ALPHA_signs())
    MODEL.lua.vrik_OPAQUE_restsigns(MODEL.lua.vrik_ALPHA_restsigns())
    MODEL.lua.vrik_OPAQUE_tripinfo(MODEL.lua.vrik_ALPHA_tripinfo())
    MODEL.lua.vrik_OPAQUE_tripinfohor(MODEL.lua.vrik_ALPHA_tripinfohor())
    MODEL.lua.vrik_OPAQUE_tripcompbg(MODEL.lua.vrik_ALPHA_tripcompbg())
    MODEL.lua.vrik_OPAQUE_tripcomptxt(MODEL.lua.vrik_ALPHA_tripcomptxt())
    MODEL.lua.vrik_OPAQUE_cityhouse(MODEL.lua.vrik_ALPHA_cityhouse())
    MODEL.lua.vrik_OPAQUE_border(MODEL.lua.vrik_ALPHA_border())
    MODEL.lua.vrik_OPAQUE_signpost(MODEL.lua.vrik_ALPHA_signpost())
    MODEL.lua.vrik_OPAQUE_JTV(MODEL.lua.vrik_ALPHA_JTV())
    MODEL.lua.vrik_OPAQUE_mini(MODEL.lua.vrik_ALPHA_mini())
    MODEL.lua.vrik_OPAQUE_laneinfo(MODEL.lua.vrik_ALPHA_laneinfo())
    MODEL.lua.vrik_OPAQUE_speedlimit(MODEL.lua.vrik_ALPHA_speedlimit())
    MODEL.lua.vrik_OPAQUE_speedalert(MODEL.lua.vrik_ALPHA_speedalert())
    MODEL.lua.vrik_OPAQUE_tripiconhor(MODEL.lua.vrik_ALPHA_tripiconhor())
    MODEL.lua.vrik_OPAQUE_table(MODEL.lua.vrik_ALPHA_table())
    if MODEL.lua.vrikinfoOnMapOpen() then
  	MODEL.lua.vrik_OPAQUE_infobar = 27
    else
  	MODEL.lua.vrik_OPAQUE_infobar(MODEL.lua.vrik_ALPHA_infobar())
    end
    if MODEL.lua.vrik_IconOpaqueAuto() and MODEL.lua.vrikinfoFont() == 2 then
	MODEL.lua.vrik_OPAQUE_infoicon = 32
    else
  	MODEL.lua.vrik_OPAQUE_infoicon(MODEL.lua.vrik_ALPHA_infoicon())
    end
  else
    if MODEL.lua.vrikColorInfobar() then
    	MODEL.lua.vrik_OPAQUE_infobar = 32
    else
    	MODEL.lua.vrik_OPAQUE_infobar = 0
    end
    MODEL.lua.vrik_OPAQUE_maneuver = 32
    MODEL.lua.vrik_OPAQUE_secondmaneuver = 32
    MODEL.lua.vrik_OPAQUE_nextstreet = 32
    MODEL.lua.vrik_OPAQUE_quickmenu = 32	
    MODEL.lua.vrik_OPAQUE_currstreet = 32
    MODEL.lua.vrik_OPAQUE_signs = 32
    MODEL.lua.vrik_OPAQUE_restsigns = 32
    MODEL.lua.vrik_OPAQUE_infoicon = 32
    MODEL.lua.vrik_OPAQUE_tripinfo = 32
    MODEL.lua.vrik_OPAQUE_tripinfohor = 32
    MODEL.lua.vrik_OPAQUE_tripcompbg = 32
    MODEL.lua.vrik_OPAQUE_tripcomptxt = 32
    MODEL.lua.vrik_OPAQUE_cityhouse = 32
    MODEL.lua.vrik_OPAQUE_border = 32
    MODEL.lua.vrik_OPAQUE_signpost = 32
    MODEL.lua.vrik_OPAQUE_JTV = 32
    MODEL.lua.vrik_OPAQUE_mini = 32
    MODEL.lua.vrik_OPAQUE_laneinfo = 32
    MODEL.lua.vrik_OPAQUE_speedlimit = 32
    MODEL.lua.vrik_OPAQUE_speedalert = 32
    MODEL.lua.vrik_OPAQUE_tripiconhor = 32
    MODEL.lua.vrik_OPAQUE_table = 32
  end
end

sc_LaneInfoVisibleOnchange_orig = sc_LaneInfoVisibleOnchange
sc_LaneInfoVisibleOnchange = function()
  if MODEL.lua.laneInfoVisible() then
    sprLaneInfoEasy:BLENDALPHA(0, MODEL.lua.vrik_OPAQUE_laneinfo(), 20)
  else
    sprLaneInfoEasy:BLENDALPHA(MODEL.lua.vrik_OPAQUE_laneinfo(), 0, 20)
  end
end

--color settings
createState("st_rik_ColorSettings")
st_rik_ColorSettings:useLayers(backgroundLayers, "ui_rik_ColorSettings", localMenuLayers)
st_rik_ColorSettings.init = function()
  txtTitle.TEXT = m_i18n("Kleuren")
  sc_init_local_menu("ui.colorLocalMenu")
end

sc_rik_ColorSet_OnRelease = function()
  sc_NextStateAnim(st_rik_ColorSettings, "horz_scroll", 1, "")
end

sc_rik_ColorBarChange = function()
  if MODEL.lua.vrikColorInfobar() then
    MODEL.lua.vrikColorChangeInfobar(MODEL.lua.vrikColorSetBar())
  else
    MODEL.lua.vrikColorChangeInfobar(MODEL.lua.vrikColorSetMid())
  end
  if (MODEL.lua.vrik_ALPHA_infobar() >= MODEL.lua.vrik_ALPHA_nextstreet()) and MODEL.lua.vrikColorInfobar() and MODEL.lua.vrikinfobarAll() and MODEL.lua.vrikinfobar() then
    MODEL.lua.vrikColorSetHw(MODEL.lua.vrikColorSetBar())
  else
    MODEL.lua.vrikColorSetHw(MODEL.lua.vrikColorSetMid())
  end
  sc_rik_Opaque_OnOff()
end

sc_rik_ResetColor_OnRelease = function()
  sc_close_local_menu()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Would you like to reset all?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_rik_ResetColor", m_i18n("Reset to Defaults"), "", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

sc_rik_ResetColor = function()
  MODEL.lua.vrikColorSet = 0
  MODEL.lua.vrikColorSetMan = 0
  MODEL.lua.vrikColorSetDark = 0
  MODEL.lua.vrikColorSetDarkHor = 1
  MODEL.lua.vrikColorSetCs = 0
  MODEL.lua.vrikColorSetMid = 0
  MODEL.lua.vrikColorSetBorder = 0
  MODEL.lua.vrikColorSetBar = 0
  MODEL.lua.vrikColorChangeInfobar = 0
  MODEL.lua.vrikColorInfobar = false
  MODEL.lua.vrik_ALPHA_infobar = 0
  MODEL.lua.vrikinfoFontColor = 4
  MODEL.lua.vrikColorFontStreet = 0
  sc_rik_Opaque_OnOff()
end


--font size settings
createState("st_rik_FontSetSingle")
st_rik_FontSetSingle:useLayers(backgroundLayers, "ui_rik_FontSetSingle")
st_rik_FontSetSingle.init = function()
  txtTitle.TEXT = m_i18n("Font Instellingen")
end

sc_rik_FontSetSingle_OnRelease = function()
  sc_NextStateAnim(st_rik_FontSetSingle, "horz_scroll", 1, "")
end

sc_rik_FontSizeChange = function()
  if not MODEL.lua.vrikSetFS_single() then 
--    if MODEL.lua.vrikFontSizeAll() == 100 then
--  	MODEL.lua.vrikFontSizeInfobar = 106
--	MODEL.lua.vrikChangeFS_infobar = 106
--    end
    if MODEL.lua.vrikFontSizeAll() > 116 then
  	MODEL.lua.vrikChangeFS_speedlimit = 134    
  	MODEL.lua.vrikChangeFS_tripcomp = 116
    	MODEL.lua.vrikChangeFS_distman = 138
--	MODEL.lua.vrikChangeFS_infobar = 124
--	MODEL.lua.vrikFontSizeInfobar = 124
    else
  	MODEL.lua.vrikChangeFS_speedlimit(MODEL.lua.vrikFontSizeAll())
  	MODEL.lua.vrikChangeFS_tripcomp(MODEL.lua.vrikFontSizeAll())
    	MODEL.lua.vrikChangeFS_distman(MODEL.lua.vrikFontSizeAll())
--	MODEL.lua.vrikChangeFS_infobar(MODEL.lua.vrikFontSizeAll())
--	MODEL.lua.vrikFontSizeInfobar(MODEL.lua.vrikFontSizeAll())
    end
    MODEL.lua.vrikChangeFS_tripinfo(MODEL.lua.vrikFontSizeAll())
    MODEL.lua.vrikChangeFS_housenum(MODEL.lua.vrikFontSizeAll())
    MODEL.lua.vrikChangeFS_highw(MODEL.lua.vrikFontSizeAll())
    MODEL.lua.vrikChangeFS_advspeed(MODEL.lua.vrikFontSizeAll())
  else
    MODEL.lua.vrikChangeFS_distman(MODEL.lua.vrikFontSizeDistman())
    MODEL.lua.vrikChangeFS_tripinfo(MODEL.lua.vrikFontSizeTripinfo())
    MODEL.lua.vrikChangeFS_tripcomp(MODEL.lua.vrikFontSizeTripcomp())
    MODEL.lua.vrikChangeFS_housenum(MODEL.lua.vrikFontSizeHousenum())
    MODEL.lua.vrikChangeFS_highw(MODEL.lua.vrikFontSizeHighw())
    MODEL.lua.vrikChangeFS_advspeed(MODEL.lua.vrikFontSizeAdvspeed())
    MODEL.lua.vrikChangeFS_speedlimit(MODEL.lua.vrikFontSizeSpeedlimit())
  end
    MODEL.lua.vrikChangeFS_infobar(MODEL.lua.vrikFontSizeInfobar())
end

--extra routesettings
createState("st_hozz_Extraroutesettings")
st_hozz_Extraroutesettings:useLayers(backgroundLayers, "ui_hozz_Extraroutesettings", localMenuLayers)
st_hozz_Extraroutesettings.init = function()
  txtTitle.TEXT = m_i18n("Extra Route Settings")
  sc_init_local_menu("ui.hozzresetLocalMenu")
end

sc_hozz_Extrasettings_OnRelease = function()
  sc_NextStateAnim(st_hozz_Extraroutesettings, "horz_scroll", 1, "")
end

sc_hozz_ResetExtra_OnRelease = function()
  sc_close_local_menu()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Would you like to reset all?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_hozz_ResetExtra", m_i18n("Reset to Defaults"), "", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

sc_hozz_ResetExtra = function()
  MODEL.lua.vAvoidUTurn = false
  MODEL.lua.RoadBlocking = false
  MODEL.lua.set_route_start_time_enabled = false
  MODEL.lua.routeComparingEnabled = true
end

--other settings
createState("st_rik_VisualSettingsOther")
st_rik_VisualSettingsOther:useLayers(backgroundLayers, "ui_rik_VisualSettingsOther", localMenuLayers)
st_rik_VisualSettingsOther.init = function()
  txtTitle.TEXT = m_i18n("Meer...")
  sc_init_local_menu("ui.otherLocalMenu")
end

sc_rik_VisualOther_OnRelease = function()
  sc_NextStateAnim(st_rik_VisualSettingsOther, "horz_scroll", 1, "")
end

sc_rik_ResetOther_OnRelease = function()
  sc_close_local_menu()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Would you like to reset all?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_rik_ResetOther", m_i18n("Reset to Defaults"), "", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

sc_rik_ResetOther = function()
  MODEL.lua.vrikShowDynamicNextStreet = true
  MODEL.lua.vrikTiHorizontal = true
  MODEL.lua.vrikShowStaticCurrStreet = false
  MODEL.lua.vrikShowSecMan = 4
  MODEL.lua.vrikShowTimeToMan = 1
  MODEL.lua.vrikShowLaneInfo = 1
  MODEL.lua.vrik_ALPHA_tripiconhor = 16
  MODEL.lua.vrikIconOnQMBtn = 3
  MODEL.lua.vrikVRFontColor = 2
  MODEL.lua.vrikTimeFontColor = 0
  MODEL.lua.hozz_battstatus = true
  MODEL.lua.hozz_compass = false
  MODEL.lua.mute_hozz = 2
end


--infobar settings
createState("st_rik_InfobarSettings")
st_rik_InfobarSettings:useLayers(backgroundLayers, "ui_rik_InfobarSettings", localMenuLayers)
st_rik_InfobarSettings.init = function()
  txtTitle:SET(m_i18n("Infobalk"))
  sc_init_local_menu("ui.infobarLocalMenu")
end

sc_rik_ResetInfobar_OnRelease = function()
  sc_close_local_menu()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Would you like to reset all?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_rik_ResetInfobar", m_i18n("Reset to Defaults"), "", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

sc_rik_ResetInfobar = function()
  MODEL.lua.vrikinfobarAll = true
  MODEL.lua.vrikinfobar = false
  MODEL.lua.vrikinfobarAdd = true
  MODEL.lua.vrikinfoFont = 2
  MODEL.lua.vrikinfoTripLeft = 2
  MODEL.lua.vrikinfoTripRight = 3
  MODEL.lua.vrikinfoTripLeft_open = 7
  MODEL.lua.vrikinfoTripRight_open = 7
  MODEL.lua.vrikinfoIconLeft = 1
  MODEL.lua.vrikinfoIconRight = 1
  MODEL.lua.vrikinfoFontNorm = true
--  MODEL.lua.vrikinfoFontSize = 2
  MODEL.lua.vrikinfoWidth = false
  MODEL.lua.vrik_IconOpaqueAuto = true
  MODEL.lua.vrikinfoWayPointsLeft = true
  MODEL.lua.vrikinfoWayPointsRight = false
end

sc_rik_infobar_OnRelease = function()
  sc_NextStateAnim(st_rik_InfobarSettings, "horz_scroll", 1, "")
end

createState("st_rik_InfobarDataFields")
st_rik_InfobarDataFields:useLayers(backgroundLayers, "ui_rik_InfobarDataFields")
st_rik_InfobarDataFields.init = function()
  txtTitle.TEXT = m_i18n("Data Velden")
end

sc_rik_InfobarDataFields_OnRelease = function()
  sc_NextStateAnim(st_rik_InfobarDataFields, "horz_scroll", 1, "")
end

createState("st_rik_InfobarSetOnMap")
st_rik_InfobarSetOnMap:useLayers(primary, "ui_rik_InfoBar", "ui_rik_InfobarDataFields", uieffect)
st_rik_InfobarSetOnMap.init = function()
end

sc_rik_InfobarSetOnMapOpen = function()
  sc_NextStateAnim(st_rik_InfobarSetOnMap, "fade", 0, "")
  MODEL.lua.vrikinfoOnMapOpen = true
  MODEL.lua.vrik_OPAQUE_infobar = 27
  MODEL.map.primary.make2stillbackground(true)
end

sc_rik_InfobarSetOnMapClose = function()
  if MODEL.lua.vEasyNavTripInfoOpen() and not MODEL.lua.vrikTiHorizontal() then
    MODEL.lua.vEasyNavTripInfoOpen = false
  end
  MODEL.map.primary.make2stillbackground(false)
  MODEL.lua.vrikinfoOnMapOpen = false
  MODEL.lua.vrik_OPAQUE_infobar(MODEL.lua.vrik_ALPHA_infobar())
  sc_back()
end

sc_rik_InfobarNavTripInfoChange = function()
  if MODEL.lua.vrikinfoOnMapOpen() and MODEL.lua.vEasyNavTripInfoOpen() then
    MODEL.lua.vEasyNavTripInfoOpen = false
  end
end

sc_back = function()
  MODEL.screen.msgbox.switch_on()
  Back:trigger()
end

sc_rik_InfobarNavTripInfoChange_open = function()
  if MODEL.lua.vrikinfoOnMapOpen() and not MODEL.lua.vEasyNavTripInfoOpen() then
    MODEL.lua.vEasyNavTripInfoOpen = true
  end
end

--
sc_rik_infoAllOn = function()
  if MODEL.lua.vrikinfobarAll() then
    MODEL.lua.vrikinfobar = true
    MODEL.lua.vrikinfobarAdd = true
  else
    MODEL.lua.vrikinfobar = false
    MODEL.lua.vrikinfobarAdd = false  
  end
  sc_rik_ColorBarChange()
end

sc_rik_infoAllOff = function()
  if not MODEL.lua.vrikinfobar() and not MODEL.lua.vrikinfobarAdd() then
    MODEL.lua.vrikinfobarAll = false
  else
    MODEL.lua.vrikinfobarAll = true
  end
  sc_rik_ColorBarChange()
end


--EasyNav Layers
st_EasyNav:useLayers(primary, "ui_PropLayer", "ui_EasyNav_Main", "ui_rik_InfoBar", "ui_SideList", "ui_EasyNav_NextMan", "ui_EasyNav_DragMode", "ui_EasyNav_Cockpit", "ui_SimulationControls", "ui_SimulationStop", "ui_StoreDemoLayer", "ui_NavigateMapSpeedLimit", "ui_SpeedCamWarningLayer", "ui_NavigateMapSingpost", "ui_NavigateMapJunctionView", "ui_TunnelOverview", "ui_NavigateMapDriverAlerts", "ui_Detect_GPS", "ui_AutodetectGPSReceiver", "ui_TripInfoPanel_Tmc", "ui_TripInfoPanel_Via", "ui_TripInfoPanel", "ui_EasyNav_RoundaboutIcons", "ui_StartpointCancel", localMenuLayers, "ui_BugReport", "ui_MapLocalMenuOpenClose", "ui_MapLocalMenuListLayer", "ui_Quick_Menu_Background", "ui_RecalcMsgBoxNavigate", "ui_EasyNav_SkipMenu", "ui_HighwayInfo", "ui_NavigateMapTruckAlert", uieffect)
st_EasyNav.active = nil
st_EasyNav.enter = function()
  gGoTextIsSelect = true
  gKeepMapPosAfterBack = false
end

st_EasyNav.init_orig = st_EasyNav.init
st_EasyNav.init = function()
  local messageBoxY = scGetMapPopupY()
  sc_PosRecalcLayer()
  sc_Set_Presets()
  sc_init_local_menu("ui.lm_st_EasyNav")
  primary:ONMAPCLICK(sc_OpenMapLocalMenu)
  obs_enter_drag_mode:START("no_trigger")
  if MODEL.lua.dragMode() then
    sc_dragmode(true)
    MODEL.lua.mainMenuMode = false
  else
    if MODEL.navigation.is_in_simulation() then
      sc_SetFlyOverMode()
    else
      sc_set_Nav2D3D()
      MODEL.lua.mainMenuMode = false
    end
    sc_SetCockpitMap()
    sc_Set_Follow_On()
    MODEL.map.primary.show_cursor = false
  end
  ATTACH_LANEINFO(sprLaneInfoEasy, "laneinfo.ini")
  ATTACH_LANEINFO(sprLaneInfoSignpost, "laneinfo_signpost.ini")
  ui.bLaneInfoSignpostForceRedraw = 1
  local junctionViewType = sc_GetSysEntry("navigation", "junction_view_type", "NNG")
  local junctionViewContentResolution = sc_GetSysEntry("navigation", "junction_view_content_resolution_override", gJunctionViewContentResolution)
  gJunctionViewNeedsSignpost = sc_GetSysEntry("navigation", "junction_view_needs_signpost", true)
  if junctionViewType == "NNG" then
    ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], gJunctionViewDirectory)
  elseif junctionViewType == "mixed" then
    ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], gJunctionViewDirectory .. ";" .. junctionViewContentResolution)
  elseif junctionViewType == "NNG_NQ" then
    ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], "16_9_NQ_Roads")
  elseif junctionViewType == "NQ" then
    ATTACH_JUNCTIONVIEW(sprJunctionView, junctionViewIni[junctionViewType], gJunctionViewDirectory .. ";" .. junctionViewContentResolution)
  end
  if MODEL.map.primary.state() == "2dnorthup" or MODEL.map.primary.state() == "simulate_2d_nu" then
    ui_SimulationControls:Y(uiResH * 32 / 100)
    MODEL.map.primary.car_posy = 50
  else
    ui_SimulationControls:Y(0)
    MODEL.map.primary.car_posy = 80
  end
  st_EasyNav.active = true
  obs_want_junctionview:START()
  obs_TunnelOverview:START()
  ui_Local_Menu_Background.ALPHA = 0
  ui_Local_Menu_Background_Disabled:HIDE()
  if not MODEL.map.primary.center_follow() and not gKeepMapPosAfterBack then
    MODEL.map.primary.center_noanim(MODEL.map.cursor.position())
  end
  gKeepMapPosAfterBack = false
  MODEL.mydata.tracks.show_on_map = MODEL.lua.TrackShowOnMap()
  if showDriveCarefully and MODEL.interface.drive_carefully() then
    sc_drive_carefully_init()
  end
  ui.vTmcButtonBlinkCounter = 0
  ui.vDAIsVisible = 1
  MODEL.traffic.events.sort_by("distance")
  sc_UpdateFullDelayTextOnMap()
  satPhaseTimerId = doDelayed(20, sc_CycleSatPhase, true)
  MODEL.lua.ismapvisible = true
  MODEL.navigation.restrictions_turn_change_handler = sc_TruckTurnRestrictionAlert
  MODEL.lua.vEasyNavMapMenuOpen = false
  sc_uturnonoff()
  sc_SetCarPosY()
  sc_gj_set_autorecalc()
end

sc_uturnonoff = function()
  if MODEL.lua.vAvoidUTurn() then
    MODEL.route.allow_uturn = false
  else
    MODEL.route.allow_uturn = true
  end
end

sc_dragmode = function(SetCursor)
  if MODEL.lua.LocalMenuIsClosed() then
    ASSERT(false, "Nee gewoon uit die handel")
	local centerLock = MODEL.map.primary.center_lock()
    local follow = MODEL.map.primary.center_follow()
    MODEL.map.primary.center_lock = true
    MODEL.map.primary.center_follow = true
	;sc_back_to_cockpit()
    return 
  end
  if MODEL.navigation.is_in_simulation() then
    ASSERT(false, "Navigation in simulation?")
    local centerLock = MODEL.map.primary.center_lock()
    local follow = MODEL.map.primary.center_follow()
    MODEL.map.primary.center_lock = true
    MODEL.map.primary.center_follow = true
    return 
  end  
  if st_RouteItinerMap.isActive then
    ASSERT(false, "Dragmode in itinerview?")
  end
  local mapLayer = MODEL.map.primary()
  if mapLayer.state() == "dragmode" then
    return 
  end
  mapLayer.save_state("dragmode")
  mapLayer.switch_state("dragmode")
  sc_Set_Follow_Off()
  mapLayer.show_cursor = true
  if SetCursor then
    MODEL.map.primary.cursor_icon = "cursor"
  end
  mapLayer.auto_set_cursor = true
  if SetCursor then
    MODEL.map.cursor.position = MODEL.navigation.car.position()
    MODEL.my.map.select_address(MODEL.navigation.car.position())
  end
  obs_Dragmode_Type:START("no_trigger")
  obs_InvalidateClickedListEvent:START("no_trigger")
  sc_reset_primary(false)
  if MODEL.lua.vEasyMapMode() == EMapMode.Mode_3D then
    mapLayer.autochange_mode_for_zoom = true
    sc_Easy3Ddragmode()
  else
    sc_Easy2Ddragmode()
  end
  if g_MapModeBeforeDragMode < 0 then
    g_MapModeBeforeDragMode = MODEL.lua.vEasyMapMode()
  end
end

sc_EasyMapClick = function()
  local selectedPois = MODEL.map.primary.clicked_poi_list
  if #selectedPois == 1 then
    currentPoi = selectedPois[0]
    MODEL.my.poi.select_poi(currentPoi.provider_id(), currentPoi.id())
  end
  PoiSelected = false
  gClickedPoiFlag = false
  if #selectedPois and (MODEL.map.primary.zoom():toInt() <= gPoiDistantDistance or st_ShowPoiResultOnMap.isActive) then
    sc_SetPOICursorIcon()
    PoiSelected = true
    gClickedPoiFlag = true
    g_cursor_strapped = true
  elseif MODEL.map.primary.clicked_tmc_id.valid() then
    MODEL.map.primary.cursor_icon = "cursor_tmc"
    g_cursor_strapped = true
  elseif #MODEL.map.primary.clicked_speedcam_list then
    MODEL.map.primary.cursor_icon = "cursor_speedcam"
    g_cursor_strapped = true
    sc_UpdateSpeedcamModels(MODEL.map.primary.clicked_speedcam_list[0])
  else
    MODEL.map.primary.cursor_icon = "cursor"
    g_cursor_strapped = false
  end
  if MODEL.map.primary.center_follow() then
    obs_enter_drag_mode:STOP()
    sc_dragmode(false)
    obs_enter_drag_mode:START("NO_TRIGGER")
  end
end

sc_btnSim_Stop_Easy_onrelease = function(SkipAnim)
  if not SkipAnim then
    uieffect:GRAB()
  end
  sc_BackFromDemo()
  if MODEL.lua.simulateIsDemo() then
    demoRouteLoop = false
  else
	sc_back_to_cockpit()
    primary:ONMAPCLICK(sc_EasyMapClick)
  end
  local primary = MODEL.map.primary
  if primary.state() == "simulate_2d_nu" or primary.state() == "simulate_2d" or primary.state() == "simulate" then
    primary.exit_state()
  else
    ASSERT(false, "Not in simulation mapstate?")
  end
  MODEL.route.stop_simulation()
  MODEL.screen.msgbox.switch_on()
  MODEL.navigation.autoreplan = true
  MODEL.navigation.car.is_on_highway = false
  MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
  if not SkipAnim then
    uieffect:DO_ANIM("fade", 1, "")
  end
end

--trip computer
sc_rik_TripComputer_OnRelease = function()
  if not MODEL.mydata.tracks.isrecording() then
    sc_StartTrackLog()
  end
  sc_NextStateAnim(st_trackinfo, "fade", 1, "")
end

sc_rik_ResetTripComp = function()
  MODEL.other.trips[0].reset()
end 

sc_rik_TripCompReset_OnRelease = function()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to reset trip computer?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_rik_ResetTripComp", m_i18n("Reset"), L"", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

createState("st_rik_TripSettings")
st_rik_TripSettings:useLayers(backgroundLayers, "ui_rik_TripSettings", localMenuLayers)
st_rik_TripSettings.init = function()
  txtTitle.TEXT = m_i18n("Trip Computer Settings")
  sc_init_local_menu("ui.tripcompLocalMenu")
end

sc_rik_Trip_OnRelease = function()
  sc_NextStateAnim(st_rik_TripSettings, "horz_scroll", 1, "")
end

sc_rik_ResetTripcomp_OnRelease = function()
  sc_close_local_menu()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Would you like to reset all?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_rik_ResetTripcomp", m_i18n("Reset to Defaults"), "", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "", m_i18n("Cancel"), "", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

sc_rik_ResetTripcomp = function()
  MODEL.lua.vrikTripComp = true
  MODEL.lua.vrikTripFontColor = 3
  MODEL.lua.vrikShowAvgSpeed = false
  MODEL.lua.vrikTripDataRecStop = true
  MODEL.lua.vrikRecalcInfoEnable = false
  MODEL.lua.vrikRecalcInfoColor = 1
end

st_Start.init_orig = st_Start.init
st_Start.init = function()
  sc_LoadTrafficEventTypeSettings()
  MODEL.traffic.events.sort_by(MODEL.lua.trafficEventSorting())
  sc_CreateKeyboardPanelsLocalMenu()
  sc_SetEnabledKeyboardPanels()
  sc_GetSysEntry_Init()
  if MODEL.lua.Currency() == L"" then
    MODEL.lua.Currency = MODEL.regional.current_language.currency()
  end
  if MODEL.other.debug() then
    obs_saved_parameters_modified = var.observer({MODEL = MODEL.route.parameters_modified, ONCHANGE = function()
      if MODEL.route.parameters_modified() then
        ASSERT(MODEL.route.vehicle_type() == MODEL.mydata.vehicle_profile.list[MODEL.mydata.vehicle_profile.selected_profile()].vehicle_type())
      else
        MODEL.route.list.navigated.settings.check_consistency_with_global_settings()
        sc_CheckOffroadParams()
      end
    end
    , TRIGGER_ON_START = false})
  end
  if gSkinDebug then
    REGISTERKEYCODE("PREVTHEME", 33)
    KEY("PREVTHEME", sc_SelectPrevTheme)
    REGISTERKEYCODE("NEXTTHEME", 34)
    KEY("NEXTTHEME", sc_SelectNextTheme)
  end
  if gSchemeDebug then
    REGISTERKEYCODE("PREVSCHEME", 35)
    KEY("PREVSCHEME", sc_MapColorSchemePrev_debug)
    REGISTERKEYCODE("NEXTSCHEME", 36)
    KEY("NEXTSCHEME", sc_MapColorSchemeNext_debug)
  end
  MODEL.mydata.tracks.show_on_map = false
  MODEL.route.list.navigated.waypoints.autocreate_start = true
  MODEL.screen.msgbox.pause_tags("popup", true)
  MODEL.regional.keyboard.update_panel_list()
  lm_CockpitList.no_route:append(lm_CockpitList[vCockpitFieldNoRoute1()], lm_CockpitList[vCockpitFieldNoRoute2()], lm_CockpitList[vCockpitFieldNoRoute3()])
  lm_CockpitList.has_route:append(lm_CockpitList[vCockpitField1()], lm_CockpitList[vCockpitField2()], lm_CockpitList[vCockpitField3()])
  local no_route_closed_id = _G["vCockpitFieldNoRoute" .. tostring(vCockpitFieldNoRouteClosed())]()
  lm_CockpitList.no_route_closed:append(lm_CockpitList[no_route_closed_id]) 
  local has_route_closed_id = _G["vCockpitField" .. tostring(vCockpitFieldClosed())]()
  lm_CockpitList.has_route_closed:append(lm_CockpitList[has_route_closed_id])  
  if MODEL.route.list.navigated.waypoints.start_is_user_selected() then
    MODEL.gps.stop()
    MODEL.navigation.car.position = MODEL.route.list.navigated.waypoints.list[0].real_position()
  else
    MODEL.gps.start()
  end
  sc_UpdateOffroadModelsFromUI()
 ----------- MODEL.other.trips[0].reset()
  sc_enable_offroute_recalc()
  EXEC_STARTUP_PARAMS()
  MODEL.lua.HasPictureViewerLic = MODEL.other.license.has_license_for_module(1107296319)
  if MODEL.lua.HasPictureViewerLic() and MODEL.oasis.pictures.slideshow_time() == 0 then
    MODEL.oasis.pictures.slideshow_time = 5
  end
  sc_SetCountrySpecTMCIcon()
  MODEL.mydata.history.sort_smart()
  sc_SetEasyDefaulSett()
  sc_Map_States_Init()
  sc_vehicle_size()
  if sc_start_customize ~= nil then
    sc_start_customize()
  end
  MODEL.lua.dateDelimiter = MODEL.regional.dateformat() % 3
  MODEL.lua.dateFormat = MODEL.regional.dateformat() / 3
  obs_AutoTimeZoneError:START()
  sc_TMC_SearchResult()
  if MODEL.EXISTS.tmc.src.http.enabled() then
    MODEL.lua.OnlineTrafficExists = true
    if MODEL.network.supported() and MODEL.tmc.src.http.enabled() then
      obs_OnlineTrafficError.TRIGGER_ON_START = true
      obs_OnlineTrafficError:START()
    else
      MODEL.tmc.src.http.enabled = false
    end
  else
    MODEL.lua.OnlineTrafficExists = false
  end
  sc_ManualDetourGetter()
  if vLastDayColorProfile() ~= "" or MODEL.interface.colorprofile.day_list[MODEL.interface.colorprofile.day_list.index()].original_name() == "COLORSCHEME~Minimal" then
    local DayIndex = MODEL.interface.colorprofile.day_list.find_by_name(translate(vLastDayColorProfile()))
    local NightIndex = MODEL.interface.colorprofile.night_list.find_by_name(translate(vLastNightColorProfile()))
    if DayIndex == -1 then
      DayIndex = 0
    end
    if NightIndex == -1 then
      NightIndex = 0
    end
    MODEL.interface.colorprofile.day_list.index = DayIndex
    MODEL.interface.colorprofile.night_list.index = NightIndex
    ui.vLastDayColorProfile = ""
    ui.vLastNightColorProfile = ""
  end
  ATTACHANIMLAYER(uieffect)
  sc_Set_DayNightMode()
  MODEL.navigation.watched_restrictions = bit.bor(EWatchedRestrictions.Vehcile, EWatchedRestrictions.SoftTruck, EWatchedRestrictions.HardTruck)
  if PERSISTENT.vfirst_start_default_settings() then
    sc_first_start_default_settings()
  end
  sc_BuildMapLocalMenu()
  ui.fullMapLocalMenuList:sort("menu_index")
  MODEL.ui.lmHighwaySettings.resize(4)
  MODEL.ui.lm_trackColor.resize(16)
  MODEL.lua.truckLicensed = MODEL.EXISTS.mydata.truck()
  MODEL.oasis.travel.initialize_data()
  if MODEL.lua.vEasyWizModeOnFirstStart() then
    sc_btnASM_ConfigWizard_OnRelease()
  else
    sc_GoToStartState(false)
    MODEL.lua.StartupVP = true
    gVSelect = sc_GetSysEntry("interface", "vehicle_selection", false)
    if sc_GetSysEntry("interface", "vehicle_selection_truck_only", true) then
      if MODEL.route.vehicle_type() == 3 and MODEL.lua.truckLicensed() and MODEL.lua.vrikTruckSetAllowed() then
        if gVSelect then
          sc_NextStateAnim(st_SettingVehicle, "fade", 1, "")
        else
          sc_EditCurrentVehicleProfile()
        end
      else
        MODEL.lua.StartupVP = false
      end
    elseif gVSelect then
      sc_NextStateAnim(st_SettingVehicle, "fade", 1, "")
    else
      sc_EditCurrentVehicleProfile()
    end
  end
  sc_SetVehicleSpecificSettings()
  sc_StartParkingAD()
  obs_Tunnel:START("NO_TRIGGER")
  obs_destination:START("NO_TRIGGER")
  obs_TruckWaiting_Starter:START("NO_TRIGGER")
  sc_StartCheckingRestrictions()
  if MODEL.EXISTS.other.slapi() then
    obs_slapi_routecalculated:START("NO_TRIGGER")
  end
  MODEL.route.histspeed.use_timeslice = false
  MODEL.navigation.car.map_provider_change_handler = sc_MapProviderChanged
  ui_MapLocalMenuListLayer.X = uiResW
  gUserPOI_Provider = MODEL.poi.find_provider("userpoi")
  gROPoi_Provider = MODEL.poi.find_provider("ropoi")
  local exitTimeout = sc_GetSysEntry("debug", "exit_timeout", -1)
  if exitTimeout ~= -1 then
    doDelayed(50 * exitTimeout, sc_DoExit)
  else
    local restartTimeout = sc_GetSysEntry("debug", "restart_timeout", -1)
    if restartTimeout ~= -1 then
      doDelayed(50 * restartTimeout, sc_Restart)
    end
  end
  if MODEL.EXISTS.other.license.subscriptions.ui_is_ready() then
    MODEL.other.license.subscriptions.ui_is_ready = true
  end
  if MODEL.lua.CockpitType() == 2 then
    MODEL.lua.vEasyNavTripInfoOpen = true
  end
  if MODEL.lua.ForceRealTimeCollect() then
    sc_ForceRealTimeCollect()
  end
end

sc_GotoDestinationMenu_orig = sc_GotoDestinationMenu
sc_GotoDestinationMenu = function()
  if not MODEL.other.trips[0].paused() then
    MODEL.other.trips[0].pause()
  end
  if MODEL.mydata.tracks.data_record() and MODEL.lua.vrikTripDataRecStop() then
    sc_StopTrackLog()
  end
  if MODEL.mydata.tracks.record_auto_track() then
    sc_SplitTrackLog()
  end
  ui.vDestinationReachedPopoUpID = -1
  if gArrivedAtParking then
    MODEL.navigation.parking_ad.wait_for_dest()
  else
    sc_DeleteRouteKeepStart()
  end
  gEnableSummaryInDestinationMenu = true
  MODEL.lua.DestinationMenuShown = false
  MODEL.lua.ShowTripInfo_automotive = true
  if MODEL.lua.automotive() then
    MODEL.ui.vTripLogSavedAtDestination = false
    sc_NextStateAnim(st_trackinfo, "horz_scroll", 1, "")
  else
    sc_NextStateAnim(st_DestinationMenu, "horz_scroll", 1, "")
  end
end


--recalc info
sc_rik_blink = function()
  if not MODEL.lua.routeCalculation_todo() or not MODEL.lua.vrikRecalcInfoShow() then 
    if MODEL.navigation.distance_to_destination() > 0 and rikRICalckEvent == 0 then
	MODEL.lua.vrikRITmpDist = MODEL.navigation.distance_to_destination()
	MODEL.lua.vrikRITmpTime = MODEL.navigation.time_to_destination() 
    end	
  end
  if MODEL.navigation.has_route() then
    local DestATPETA = MODEL.navigation.eta_at_destination()
    local DestATPTmp = MODEL.lua.vrikATPTmpTime()
    if DestATPTmp > DestATPETA then
	MODEL.lua.vrikATPShowArrTime = (DestATPTmp-DestATPETA)
    else
	MODEL.lua.vrikATPShowArrTime = (DestATPTmp-DestATPETA) * -1
    end
  end
end

sc_rik_recalculate_start = function()
	rikRICalckEvent = 1
end

sc_rik_recalculate_end = function()
  if MODEL.lua.vrikRITmpDist() == 0 or MODEL.lua.vrikRITmpTime() == 0 then
    MODEL.lua.vrikRITmpDist = MODEL.navigation.distance_to_destination()
    MODEL.lua.vrikRITmpTime = MODEL.navigation.time_to_destination()
  else
    if (MODEL.lua.vrikRITmpDist() ~= MODEL.navigation.distance_to_destination() or MODEL.lua.vrikRITmpTime() ~= MODEL.navigation.time_to_destination()) and MODEL.lua.vrikRecalcInfoEnable() then
	MODEL.lua.vrikRIShowTmpDist = MODEL.lua.vrikRITmpDist()-MODEL.navigation.distance_to_destination()
	MODEL.lua.vrikRIShowTmpTime = MODEL.lua.vrikRITmpTime()-MODEL.navigation.time_to_destination()			
	    doDelayed(30, function()
		if MODEL.navigation.distance_to_destination() > 0 then
		    MODEL.lua.vrikRITmpDist = MODEL.navigation.distance_to_destination()
		    MODEL.lua.vrikRITmpTime = MODEL.navigation.time_to_destination()
		    MODEL.lua.vrikRecalcInfoShow = true
			killDelayed(rikDel)
			rikDel = doDelayed(800, function()
				MODEL.lua.vrikRecalcInfoShow = false
			end
			)				
		end
	    end
	    )
    end
  end
  killDelayed(rikDel2)
  rikDel2 = doDelayed(60, function()
	rikRICalckEvent = 0
  end
  )	
end

sc_route_deleted_orig = sc_route_deleted
sc_route_deleted = function()
  sc_rik_route_end()
  sc_ResetRouteParams()
  MODEL.lua.JunctionViewHiddenByUser = false
  MODEL.route.list.navigated.off_road = MODEL.lua.ptp_navigation()
end

sc_rik_route_end = function()
  MODEL.lua.vrikRITmpDist = 0
  MODEL.lua.vrikRITmpTime = 0
  MODEL.lua.vrikATPTmpTime = 0
  MODEL.lua.vrikRecalcInfoShow = false
end

sc_rik_ATP_Reset_OnRelease = function()
  MODEL.screen.msgbox.new.setup(2)
  MODEL.screen.msgbox.new.set_line(1, m_i18n("Are you sure you want to reset time?"))
  MODEL.screen.msgbox.new.setup_button(1, "sc_rik_ResetATP", m_i18n("Reset"), L"", "ico_done_mid.bmp#3")
  MODEL.screen.msgbox.new.setup_button(2, "sc_CancelExit", m_i18n("Cancel"), L"", "ico_cancel_mid.bmp#3")
  MODEL.screen.msgbox.create_new()
end

sc_rik_ResetATP = function()
  MODEL.lua.vrikATPTmpTime = MODEL.navigation.eta_at_destination()
end


--truck
sc_ShowTruckCurrentTimes_orig = sc_ShowTruckCurrentTimes
sc_ShowTruckCurrentTimes = function()
  sc_NextStateAnim(st_rik_CurrentDrivingTimes, "horz_scroll", 1, "")
end
 
createState("st_rik_CurrentDrivingTimes")
st_rik_CurrentDrivingTimes:useLayers(backgroundLayers, "ui_CurrentDrivingTimes", localMenuLayers)
st_rik_CurrentDrivingTimes.init = function()
  txtTitle.TEXT = m_i18n("TRUCK~Current Times")
  sc_init_local_menu("ui.lm_moremenu_trucktimers")
end

sc_rik_ShowTruckCurrentTimesMenu = function()
  sc_NextStateAnim(st_rik_CurrentDrivingTimesMenu, "horz_scroll", 1, "")
end

createState("st_rik_CurrentDrivingTimesMenu")
st_rik_CurrentDrivingTimesMenu:useLayers(backgroundLayers, "ui_CurrentDrivingTimes")
st_rik_CurrentDrivingTimesMenu.init = function()
  txtTitle.TEXT = m_i18n("TRUCK~Current Times")
end

sc_rik_Truck_OnRelease = function()
  sc_NextStateAnim(st_rik_TruckSettings, "horz_scroll", 1, "")
end

createState("st_rik_TruckSettings")
st_rik_TruckSettings:useLayers(backgroundLayers, "ui_rik_TruckSettings")
st_rik_TruckSettings.init = function()
  txtTitle.TEXT = m_i18n("TRUCK~Truck Settings")
end

--on map
sc_ChangeTruckCurrentTimesOnMap = function()
  MODEL.lua.vrikTruckTimeChange = true
  sc_NextStateAnim(st_rik_CurrentDrivingTimes, "horz_scroll", 1, "")
end

sc_rik_ChangeTruckCurrentDrivingTime = function()
  MODEL.lua.vrikTruckTime = 1
  MODEL.lua.vrikTruckTimeChange = false
  sc_back()
end

sc_rik_ChangeTruckCurrentBreakTime = function()
  MODEL.lua.vrikTruckTime = 2
  MODEL.lua.vrikTruckTimeChange = false
  sc_back()
end

sc_rik_ChangeTruckRemainingDailyDrivingTime = function()
  MODEL.lua.vrikTruckTime = 3
  MODEL.lua.vrikTruckTimeChange = false
  sc_back()
end


--panic button
sc_rik_enable_panic = function()
  if MODEL.warning.speedcam_warning() then
    MODEL.screen.msgbox.new.setup(3)
    MODEL.screen.msgbox.new.set_line(1, m_i18n("SpeedCam Database"))
    MODEL.screen.msgbox.new.setup_button(1, "sc_rik_move_panic", m_i18n("Move"), "", "ico_minimize.bmp#3")
    MODEL.screen.msgbox.new.setup_button(2, "sc_rik_delete_panic", m_i18n("Delete"), "", "ico_cancel_mid.bmp#3")
    MODEL.screen.msgbox.new.setup_button(3, "sc_back_to_cockpit", m_i18n("Cancel"), "", "")
  else
    MODEL.screen.msgbox.new.setup(2)
    MODEL.screen.msgbox.new.set_line(1, m_i18n("SpeedCam Database"))
    MODEL.screen.msgbox.new.setup_button(1, "sc_rik_restore_panic", m_i18n("Restore"), L"", "ico_done_mid.bmp#3")
    MODEL.screen.msgbox.new.setup_button(2, "sc_back_to_cockpit", m_i18n("Cancel"), L"", "")
  end
  MODEL.screen.msgbox.create_new()
end

sc_rik_move_panic = function()
  sc_SpeedcamWarningDisabled()
  NEXTSTATE(RestartState)
  doDelayed(50, function()
  START_APPLICATION("./utility/utility.exe",",1,")
    doDelayed(1,EXIT)
  end
  )
end

sc_rik_delete_panic = function()
  sc_SpeedcamWarningDisabled()
  NEXTSTATE(RestartState)
  doDelayed(50, function()
  START_APPLICATION("./utility/utility.exe",",2,")
    doDelayed(1,EXIT)
  end
  )
end

sc_rik_restore_panic = function()
  sc_SpeedcamWarningEnabled()
  NEXTSTATE(RestartState)
  doDelayed(50, function()
  START_APPLICATION("./utility/utility.exe",",3,")
    doDelayed(1,EXIT)
  end
  )
end


--start
sc_TimeJump_orig = sc_TimeJump 
sc_TimeJump = function()
  if MODEL.other.timejump() then
    MODEL.other.timejump = false
    MODEL.screen.msgbox.on_screen.close()
    if MODEL.lua.vMapMenuOpen() then
      sc_CloseMapLocalMenu(true)
    end
    if vLocalMenuEnabled() then
      sc_close_local_menu(true)
    end
    if MODEL.lua.dragMode() then
      sc_backFromdragmode()
    end
    local distanceToDestination = MODEL.navigation.distance_to_destination()
    if not MODEL.navigation.is_in_simulation() then
      if #MODEL.route.list.navigated.waypoints.list > 1 then
        if distanceToDestination < tripOffset then
          sc_DeleteRouteKeepStart()
          sc_GoTo_MainMenu()
        end
      else
        sc_GoTo_MainMenu()
      end
    end
  end
end

local sc_ResetAllRouteParams_orig = sc_ResetAllRouteParams
sc_ResetAllRouteParams = function()
	for vehicle = 0, EVehicleType.Last do
		PERSISTENT.route[vehicle].allow_env_zone = false
	end
	MODEL.lua.wAutoRecalc = true
	sc_ResetAllRouteParams_orig()
end

sc_gj_set_autorecalc = function()
	if MODEL.lua.wAutoRecalc() and not (MODEL.navigation.is_in_simulation() or MODEL.lua.simulateIsDemo()) then
		MODEL.navigation.autoreplan = true
		MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
	else
		if MODEL.navigation.has_route() then
			MODEL.navigation.autoreplan = false
			MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
		else
			MODEL.navigation.autoreplan = true
			MODEL.route.list.navigated.waypoints.autocreate_start = MODEL.navigation.autoreplan()
		end
	end
end

--start time reset
sc_ResetStartDayTime = function()
  MODEL.route.histspeed.timeslice.day = 0
  MODEL.route.histspeed.timeslice.hour = 0
  MODEL.route.histspeed.timeslice.minute = 0
  MODEL.route.histspeed.use_timeslice = true
end


--viaadd
sc_AddViaMap = function()
  if #MODEL.route.list.navigated.waypoints.list < 2 then
    ASSERT(false, "Ezt ki kene javitani, a gombot kene disabledre tenni hiszen meg nincs cel")
    return 
  end
  MODEL.route.list.navigated.recalculate_on_modify = false
  MODEL.route.list.navigated.waypoints.add_optimally()
end


--tunnel in nightmode
sc_TunnelOn = function()
  if MODEL.lua.hozzUseNightmodeInTunnel() and MODEL.map.auto_nightmode() then
    gBeforeTunnel = MODEL.screen.nightmode()
    MODEL.screen.nightmode = true
  end
end
 
sc_TunnelOff = function()
  if MODEL.lua.hozzUseNightmodeInTunnel() and MODEL.map.auto_nightmode() then
    MODEL.screen.nightmode = gBeforeTunnel
    gBeforeTunnel = false
  end
end

--waypoint stuff
sc_DeleteNextWaypoint = function()
  MODEL.lua.TK_Proximit_Via = false
  MODEL.lua.TK_Dist_Approche = MODEL.lua.TK_Zone_Approche()
  local waypoints = MODEL.route.list.navigated.waypoints
  waypoints.remove(waypoints.next_waypoint())
end

tk_CheckDist_WayPoint = function()
  if not MODEL.navigation.is_in_simulation() then
    if MODEL.navigation.distance_to_waypoint() < 50 and MODEL.route.list.navigated.waypoints.list.size() > 2 then
      MODEL.lua.TK_Proximit_Via = false
      MODEL.lua.TK_Dist_Approche = MODEL.lua.TK_Zone_Approche()
    elseif MODEL.navigation.distance_to_waypoint() < MODEL.lua.TK_Zone_Approche() and MODEL.route.list.navigated.waypoints.list.size() > 2 then
      if MODEL.navigation.distance_to_waypoint() <= MODEL.lua.TK_Dist_Approche() then
        MODEL.lua.TK_Proximit_Via = true
        MODEL.lua.TK_Dist_Approche = MODEL.navigation.distance_to_waypoint()
      elseif MODEL.lua.TK_Proximit_Via() then
        sc_DeleteNextWaypoint()
      end
    elseif MODEL.lua.TK_Proximit_Via() then
      sc_DeleteNextWaypoint()
    end
  end
end
 
tk_CheckZone_WayPoint = function()
  txt_CheckZone:TEXT(tostring(MODEL.lua.TK_Zone_Approche()))
end

tk_CheckPopup_WayPoint = function()
  txt_CheckPopup:TEXT(tostring(MODEL.lua.wskipradius()))
end

sc_GetAdvancedSpeedLimitPhase = function(speed, speed_limit)
  if MODEL.lua.TK_WayPoint() and not MODEL.route.list.navigated.calculating() and MODEL.route.list.navigated.waypoints.list.size() > 2 then
    tk_CheckDist_WayPoint()
  end
  if MODEL.warning.speedwarn_alt_tolerance() > 99 then
    if speed_limit >= speed then
      return 0
    elseif speed <= speed_limit * MODEL.warning.speedwarn_alt_tolerance() / 100 then
      return 1
    else
      return 2
    end
  elseif speed <= speed_limit * MODEL.warning.speedwarn_alt_tolerance() / 100 then
    return 0
  elseif speed > speed_limit * MODEL.warning.speedwarn_alt_tolerance() / 100 and speed_limit >= speed then
    return 1
  else
    return 2
  end
end

createState("tk_waypoint_menu")
tk_waypoint_menu:useLayers(backgroundLayers, "ui_tk_waypoint_menu", "ui_List_Background")

tk_waypoint_menu.init = function()
  txtTitle:SET(m_i18n("Waypoint Management"))
  tk_CheckPopup_WayPoint()
  tk_CheckZone_WayPoint()
end
 
tk_waypoint_menu_OnRelease = function()
  sc_NextStateAnim(tk_waypoint_menu, "horz_scroll", 1, "")
end

createState("st_Skip_Waypoint")
st_EasyNav:useLayers(primary, "ui_Skip_Waypoint")

createState("st_mute_hozz")
st_EasyNav:useLayers(primary, "ui_mute_hozz")